#include <stdio.h>
#include <features.h>
#include "igs.h"

#define _WIDTH 352
#define _HEIGHT 240


/* our objects */
class bitmap {
public:
    int _colors;
    int _bytes_per_pixel;
    int _width;
    int _height;
    void* _pBits;
    int _nBits;
    
    bitmap(int w, int h, int bpp) :
        _width(w), _height(h), _bytes_per_pixel(bpp),
        _colors(3)
    {_pBits = malloc(_nBits = _width * _height * _bytes_per_pixel);}
    ~bitmap() { if (_pBits) delete _pBits; }
    /* hand over ownership of an array that was new() */
    int Size(void) const  { return _nBits; }
    unsigned char* GetBits(void) const {return _pBits;}
    int Width(void) const { return _width;}
    int Height(void) const { return _height;}
    int Bpp(void) const {return _bytes_per_pixel;}
};

class jpeg {
    void* _pData;
    int _size;
public:
    /* hand over ownership */
    jpeg(void* p, int len) : _pData(p), _size(len) {}
    ~jpeg() {if (_pData) delete _pData;}
    int Len() const { return _size; }
    void* Bits() const { return _pData; }
};

/* functions in igs.cc */
/* more are described in igs.h */
bitmap* snap(int width, int height);
jpeg*   bmp2jpg(bitmap* pb, int q_factor);
void    YUV2RGB(unsigned long yuyv, unsigned long * p1, unsigned long * p2);


/* functions in vidcap2.cc */
void    write_jpeg(jpeg* jp, FILE* fout);
